summarylogtreecommitdiffstats
path: root/PKGBUILD
diff options
context:
space:
mode:
authorFantix King2012-09-20 14:05:46 +0800
committerFantix King2015-11-13 01:19:05 +0800
commit462e8fb70a0b3a4e9bd76f3c9026ce0fd76bbadc (patch)
treef4c40f84d5a25b76aee6879177068bcbc81200a2 /PKGBUILD
parent052102d1f699e17c805a04f96746711fa6aba0c4 (diff)
downloadaur-462e8fb70a0b3a4e9bd76f3c9026ce0fd76bbadc.tar.gz
2.16.0-2.1
Diffstat (limited to 'PKGBUILD')
-rw-r--r--PKGBUILD155
1 files changed, 58 insertions, 97 deletions
diff --git a/PKGBUILD b/PKGBUILD
index b66913908f4..180c7589722 100644
--- a/PKGBUILD
+++ b/PKGBUILD
@@ -1,150 +1,105 @@
-# $Id: PKGBUILD 144552 2015-10-21 09:06:37Z heftig $
+# $Id: PKGBUILD 73695 2012-07-14 13:05:07Z allan $
# Maintainer: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
# Contributor: Jan de Groot <jgc@archlinux.org>
# Contributor: Allan McRae <allan@archlinux.org>
-# x32 Maintainer: Fantix King <fantix.king@gmail.com>
# toolchain build order: linux-api-headers->glibc->binutils->gcc->binutils->glibc
-# NOTE: valgrind-multilib requires rebuild with each major glibc version
-
+# NOTE: valgrind requires rebuilt with each major glibc version
_pkgbasename=glibc
pkgname=libx32-$_pkgbasename
-pkgver=2.22
-pkgrel=3.1
-pkgdesc="GNU C Library (x32 ABI)"
+pkgver=2.16.0
+pkgrel=2.1
+pkgdesc="GNU C Library for X32 ABI"
arch=('x86_64')
url="http://www.gnu.org/software/libc"
license=('GPL' 'LGPL')
-groups=()
-depends=()
-makedepends=('gcc-multilib-x32>=5.2')
-backup=()
+makedepends=('gcc-multilib-x32>=4.7')
conflicts=('glibc-x32-seed')
-provides=('glibc-x32-seed')
-
-
-options=('!strip' 'staticlibs' '!emptydirs')
-
+options=('!strip' '!emptydirs')
source=(http://ftp.gnu.org/gnu/libc/${_pkgbasename}-${pkgver}.tar.xz{,.sig}
- glibc-2.22-roundup.patch
+ glibc-2.15-fix-res_query-assert.patch
+ glibc-2.15-revert-c5a0802a.patch
libx32-glibc.conf)
-md5sums=('e51e02bf552a0a1fbbdc948fb2f5e83c'
- 'SKIP'
- 'b6b7a0e8d6e6520e40e3164ae773631d'
+md5sums=('80b181b02ab249524ec92822c0174cf7'
+ '2a1221a15575820751c325ef4d2fbb90'
+ '31f415b41197d85d3bbee3d1eecd06a3'
+ '0a0383d50d63f1c02919fe9943b82014'
'34a4169d2bdc5a3eb83676a0831aae57')
-validpgpkeys=('F37CDAB708E65EA183FD1AF625EF0A436C2A4AFF') # Carlos O'Donell
-prepare() {
- cd ${srcdir}/glibc-${pkgver}
+build() {
+ cd ${srcdir}/${_pkgbasename}-${pkgver}
- # glibc-2.21..01b07c70
- patch -p1 -i $srcdir/glibc-2.22-roundup.patch
+ # fix res_query assertion
+ # http://sourceware.org/bugzilla/show_bug.cgi?id=13013
+ patch -p1 -i ${srcdir}/glibc-2.15-fix-res_query-assert.patch
- mkdir ${srcdir}/glibc-build
-}
+ # revert commit c5a0802a - causes various hangs
+ # https://bugzilla.redhat.com/show_bug.cgi?id=552960
+ patch -p1 -i ${srcdir}/glibc-2.15-revert-c5a0802a.patch
+
+ cd ${srcdir}
+ mkdir glibc-build
+ cd glibc-build
-build() {
- cd ${srcdir}/glibc-build
- #if [[ ${CARCH} = "i686" ]]; then
- # Hack to fix NPTL issues with Xen, only required on 32bit platforms
- # TODO: make separate glibc-xen package for i686
- #export CFLAGS="${CFLAGS} -mno-tls-direct-seg-refs"
- #fi
+ # Hack to fix NPTL issues with Xen, only required on 32bit platforms
+ # TODO: make separate glibc-xen package for i686
+ export CFLAGS="${CFLAGS} -mno-tls-direct-seg-refs"
if [ -x "/opt/gcc-x32-seed/bin/gcc" ]; then
echo "Using gcc-x32-seed"
- gcc_home=`ls -d /opt/gcc-x32-seed/lib/gcc/x86_64-unknown-linux-gnu/*/`
- export CC="/opt/gcc-x32-seed/bin/gcc -mx32 -B"${gcc_home}
- export CXX="/opt/gcc-x32-seed/bin/g++ -mx32 -B"${gcc_home}
- seed_params='--target=x86_64-x32-linux --build=x86_64-linux --host=x86_64-x32-linux'
+ export CC="/opt/gcc-x32-seed/bin/gcc -mx32 -B/opt/gcc-x32-seed/lib/gcc/x86_64-unknown-linux-gnu/4.7.1/"
+ export CXX="/opt/gcc-x32-seed/bin/cpp -mx32 -B/opt/gcc-x32-seed/lib/gcc/x86_64-unknown-linux-gnu/4.7.1/"
else
echo "Using gcc-multilib-x32"
export CC="gcc -mx32"
export CXX="g++ -mx32"
- seed_params=''
fi
echo "slibdir=/usr/libx32" >> configparms
- echo "rtlddir=/usr/libx32" >> configparms
- echo "sbindir=/usr/bin" >> configparms
- echo "rootsbindir=/usr/bin" >> configparms
- # remove hardening options for building libraries
- CFLAGS=${CFLAGS/-fstack-protector-strong/}
- CPPFLAGS=${CPPFLAGS/-D_FORTIFY_SOURCE=2/}
+ # remove hardening options from CFLAGS for building libraries
+ CFLAGS=${CFLAGS/-fstack-protector/}
+ CFLAGS=${CFLAGS/-D_FORTIFY_SOURCE=2/}
${srcdir}/${_pkgbasename}-${pkgver}/configure --prefix=/usr \
--libdir=/usr/libx32 --libexecdir=/usr/libx32 \
--with-headers=/usr/include \
- --with-bugurl=https://bugs.archlinux.org/ \
- --enable-add-ons \
+ --enable-add-ons=nptl,libidn \
--enable-obsolete-rpc \
--enable-kernel=2.6.32 \
--enable-bind-now --disable-profile \
--enable-stackguard-randomization \
- --enable-lock-elision \
- --enable-multi-arch \
- --disable-werror \
- ${seed_params} \
- x86_64-unknown-linux-gnux32
+ --target=x86_64-x32-linux --build=x86_64-linux --host=x86_64-x32-linux \
+ --enable-multi-arch x86_64-x32-linux
# build libraries with hardening disabled
echo "build-programs=no" >> configparms
make
-
+
# re-enable hardening for programs
sed -i "/build-programs=/s#no#yes#" configparms
- echo "CC += -fstack-protector-strong -D_FORTIFY_SOURCE=2" >> configparms
- echo "CXX += -fstack-protector-strong -D_FORTIFY_SOURCE=2" >> configparms
+ echo "CC += -fstack-protector -D_FORTIFY_SOURCE=2" >> configparms
+ echo "CXX += -fstack-protector -D_FORTIFY_SOURCE=2" >> configparms
make
# remove harding in preparation to run test-suite
- sed -i '5,7d' configparms
+ sed -i '2,4d' configparms
}
check() {
cd ${srcdir}/glibc-build
-
- if [ -x "/opt/gcc-x32-seed/bin/gcc" ]; then
- make check || true
- else
- # some failures are "expected"
- make check || true
- fi
+ make -k check
}
package() {
cd ${srcdir}/glibc-build
-
-
-
-
make install_root=${pkgdir} install
rm -rf ${pkgdir}/{etc,sbin,usr/{bin,sbin,share},var}
- # We need to keep x32 ABI specific header files
- find ${pkgdir}/usr/include -type f -not -name '*-x32.h' -delete
-
-
- # Dynamic linker
- mkdir ${pkgdir}/usr/lib
- ln -s ../libx32/ld-linux-x32.so.2 ${pkgdir}/usr/lib/
-
- # Add libx32 paths to the default library search path
- install -Dm644 "$srcdir/libx32-glibc.conf" "$pkgdir/etc/ld.so.conf.d/libx32-glibc.conf"
-
- # Symlink /usr/libx32/locale to /usr/lib/locale
- ln -s ../lib/locale "$pkgdir/usr/libx32/locale"
-
- # remove the static libraries that have a shared counterpart
- # libc, libdl, libm and libpthread are required for toolchain testsuites
- # in addition libcrypt appears widely required
- rm $pkgdir/usr/libx32/lib{anl,BrokenLocale,nsl,resolv,rt,util}.a
-
-
-
+ # We need one 32 bit specific header file
+ find ${pkgdir}/usr/include -type f -not -name stubs-x32.h -delete
# Do not strip the following files for improved debugging support
# ("improved" as in not breaking gdb and valgrind...):
@@ -154,19 +109,25 @@ package() {
# libthread_db-1.0.so
cd $pkgdir
- strip $STRIP_BINARIES \
- \
- \
- usr/libx32/getconf/*
-
+ strip $STRIP_BINARIES usr/libx32/getconf/* || true
strip $STRIP_STATIC usr/libx32/*.a
- strip $STRIP_SHARED usr/libx32/lib{anl,BrokenLocale,cidn,crypt}-*.so \
+ strip $STRIP_SHARED usr/libx32/{libanl,libBrokenLocale,libcidn,libcrypt}-*.so \
usr/libx32/libnss_{compat,db,dns,files,hesiod,nis,nisplus}-*.so \
- usr/libx32/lib{dl,m,nsl,resolv,rt,util}-*.so \
- usr/libx32/lib{memusage,pcprofile,SegFault}.so \
- usr/libx32/{audit,gconv}/*.so || true
+ usr/libx32/{libdl,libm,libnsl,libresolv,librt,libutil}-*.so \
+ usr/libx32/{libmemusage,libpcprofile,libSegFault}.so \
+ usr/libx32/{pt_chown,{audit,gconv}/*.so}
+
+ # Dynamic linker
+ mkdir ${pkgdir}/usr/lib
+ ln -s ../libx32/ld-linux-x32.so.2 ${pkgdir}/usr/lib/
+
+ # Add libx32 paths to the default library search path
+ install -Dm644 "$srcdir/libx32-glibc.conf" "$pkgdir/etc/ld.so.conf.d/libx32-glibc.conf"
+
+ # Symlink /usr/libx32/locale to /usr/lib/locale
+ ln -s ../lib/locale "$pkgdir/usr/libx32/locale"
# Fix issue that core/glibc didn't fix the path to /lib/ld-linux-x32.so.2
ln -s /usr/lib ${pkgdir}/libx32